PerFieldKnnVectorsFormat.FieldsReader (Lucene 10.5.1 core API)
Description: declaration: package: org.apache.lucene.codecs.perfield, class: PerFieldKnnVectorsFormat, class: FieldsReader

Package org.apache.lucene.codecs.perfield

# Class PerFieldKnnVectorsFormat.FieldsReader

java.lang.Object
org.apache.lucene.codecs.KnnVectorsReader
org.apache.lucene.codecs.perfield.PerFieldKnnVectorsFormat.FieldsReader

All Implemented Interfaces:
  `Closeable`, `AutoCloseable`

Enclosing class:
  `PerFieldKnnVectorsFormat`

public static class PerFieldKnnVectorsFormat.FieldsReader extends KnnVectorsReader
VectorReader that can wrap multiple delegate readers, selected by field.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `FieldsReader(SegmentReadState readState)`
  Create a FieldsReader over a segment, opening VectorReaders for each KnnVectorsFormat specified by the indexed numeric vector fields.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `checkIntegrity()`
  Checks consistency of this reader.
  `void`
  `close()`
  `void`
  `finishMerge()`
  Optional: reset or close merge resources used in the reader
  `ByteVectorValues`
  `getByteVectorValues(String field)`
  Returns the `ByteVectorValues` for the given `field`.
  `KnnVectorsReader`
  `getFieldReader(String field)`
  Return the underlying VectorReader for the given field
  `FloatVectorValues`
  `getFloatVectorValues(String field)`
  Returns the `FloatVectorValues` for the given `field`.
  `KnnVectorsReader`
  `getMergeInstance()`
  Returns an instance optimized for merging.
  `Map<String,Long>`
  `getOffHeapByteSize(FieldInfo fieldInfo)`
  Returns the desired size of off-heap memory for the given field.
  `void`
  `search(String field, byte[] target, KnnCollector knnCollector, AcceptDocs acceptDocs)`
  Return the k nearest neighbor documents as determined by comparison of their vector values for this field, to the given vector, by the field's similarity function.
  `void`
  `search(String field, float[] target, KnnCollector knnCollector, AcceptDocs acceptDocs)`
  Return the k nearest neighbor documents as determined by comparison of their vector values for this field, to the given vector, by the field's similarity function.

  ### Methods inherited from class org.apache.lucene.codecs.KnnVectorsReader

  `mergeOffHeapByteSizeMaps`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Constructor Details

  - ### FieldsReader

    public FieldsReader(SegmentReadState readState) throws IOException
    Create a FieldsReader over a segment, opening VectorReaders for each KnnVectorsFormat specified by the indexed numeric vector fields.
    Parameters:
      `readState` - defines the fields
    Throws:
      `IOException` - if one of the delegate readers throws

- ## Method Details

  - ### getMergeInstance

    public KnnVectorsReader getMergeInstance() throws IOException
    Description copied from class: `KnnVectorsReader`
    Returns an instance optimized for merging. This instance may only be consumed in the thread that called `KnnVectorsReader.getMergeInstance()`.

    The default implementation returns `this`

    Overrides:
      `getMergeInstance` in class `KnnVectorsReader`
    Throws:
      `IOException`

  - ### finishMerge

    public void finishMerge() throws IOException
    Description copied from class: `KnnVectorsReader`
    Optional: reset or close merge resources used in the reader

    The default implementation is empty

    Overrides:
      `finishMerge` in class `KnnVectorsReader`
    Throws:
      `IOException`

  - ### getFieldReader

    public KnnVectorsReader getFieldReader(String field)
    Return the underlying VectorReader for the given field
    Parameters:
      `field` - the name of a numeric vector field

  - ### checkIntegrity

    public void checkIntegrity() throws IOException
    Description copied from class: `KnnVectorsReader`
    Checks consistency of this reader.

    Note that this may be costly in terms of I/O, e.g. may involve computing a checksum value against large data files.

    Specified by:
      `checkIntegrity` in class `KnnVectorsReader`
    Throws:
      `IOException`

  - ### getFloatVectorValues

    public FloatVectorValues getFloatVectorValues(String field) throws IOException
    Description copied from class: `KnnVectorsReader`
    Returns the `FloatVectorValues` for the given `field`. The behavior is undefined if the given field doesn't have KNN vectors enabled on its `FieldInfo`. The return value is never `null`.
    Specified by:
      `getFloatVectorValues` in class `KnnVectorsReader`
    Throws:
      `IOException`

  - ### getByteVectorValues

    public ByteVectorValues getByteVectorValues(String field) throws IOException
    Description copied from class: `KnnVectorsReader`
    Returns the `ByteVectorValues` for the given `field`. The behavior is undefined if the given field doesn't have KNN vectors enabled on its `FieldInfo`. The return value is never `null`.
    Specified by:
      `getByteVectorValues` in class `KnnVectorsReader`
    Throws:
      `IOException`

  - ### search

    public void search(String field, float[] target, KnnCollector knnCollector, AcceptDocs acceptDocs) throws IOException
    Description copied from class: `KnnVectorsReader`
    Return the k nearest neighbor documents as determined by comparison of their vector values for this field, to the given vector, by the field's similarity function. The score of each document is derived from the vector similarity in a way that ensures scores are positive and that a larger score corresponds to a higher ranking.

    The search is allowed to be approximate, meaning the results are not guaranteed to be the true k closest neighbors. For large values of k (for example when k is close to the total number of documents), the search may also retrieve fewer than k documents.

    The returned `TopDocs` will contain a `ScoreDoc` for each nearest neighbor, in order of their similarity to the query vector (decreasing scores). The `TotalHits` contains the number of documents visited during the search. If the search stopped early because it hit `visitedLimit`, it is indicated through the relation `TotalHits.Relation.GREATER_THAN_OR_EQUAL_TO`.

    The behavior is undefined if the given field doesn't have KNN vectors enabled on its `FieldInfo`. The return value is never `null`.

    Specified by:
      `search` in class `KnnVectorsReader`
    Parameters:
      `field` - the vector field to search
      `target` - the vector-valued query
      `knnCollector` - a KnnResults collector and relevant settings for gathering vector results
      `acceptDocs` - `Bits` that represents the allowed documents to match, or `null` if they are all allowed to match.
    Throws:
      `IOException`

  - ### search

    public void search(String field, byte[] target, KnnCollector knnCollector, AcceptDocs acceptDocs) throws IOException
    Description copied from class: `KnnVectorsReader`
    Return the k nearest neighbor documents as determined by comparison of their vector values for this field, to the given vector, by the field's similarity function. The score of each document is derived from the vector similarity in a way that ensures scores are positive and that a larger score corresponds to a higher ranking.

    The search is allowed to be approximate, meaning the results are not guaranteed to be the true k closest neighbors. For large values of k (for example when k is close to the total number of documents), the search may also retrieve fewer than k documents.

    The returned `TopDocs` will contain a `ScoreDoc` for each nearest neighbor, in order of their similarity to the query vector (decreasing scores). The `TotalHits` contains the number of documents visited during the search. If the search stopped early because it hit `visitedLimit`, it is indicated through the relation `TotalHits.Relation.GREATER_THAN_OR_EQUAL_TO`.

    The behavior is undefined if the given field doesn't have KNN vectors enabled on its `FieldInfo`. The return value is never `null`.

    Specified by:
      `search` in class `KnnVectorsReader`
    Parameters:
      `field` - the vector field to search
      `target` - the vector-valued query
      `knnCollector` - a KnnResults collector and relevant settings for gathering vector results
      `acceptDocs` - `Bits` that represents the allowed documents to match, or `null` if they are all allowed to match.
    Throws:
      `IOException`

  - ### getOffHeapByteSize

    public Map<String,Long> getOffHeapByteSize(FieldInfo fieldInfo)
    Description copied from class: `KnnVectorsReader`
    Returns the desired size of off-heap memory for the given field. This size can be used to help determine the memory requirements for optimal search performance, which can be greatly affected by page faults when not enough memory is available.

    For reporting purposes, the size of the off-heap index structures is broken down by their file extension, which provides a logical categorization of their purpose, e.g. the `Lucene99HnswVectorsFormat` stores the HNSW graph neighbours lists in a file with the "vex" extension.

    The long value is the size in bytes of the off-heap space needed if the associated index structure were to be fully loaded in memory. While somewhat analogous to `Accountable.ramBytesUsed()` (which reports actual on-heap memory usage), the sizes reported by this method are not actual usage but rather the amount of available memory needed to fully load the index into memory, rather than an actual RAM usage requirement.

    To determine the total desired off-heap memory size for the given field:

         getOffHeapByteSize(field).values().stream().mapToLong(Long::longValue).sum();

    The default implementation returns an empty map.

    Overrides:
      `getOffHeapByteSize` in class `KnnVectorsReader`
    Parameters:
      `fieldInfo` - the fieldInfo
    Returns:
      a map of the desired off-heap memory requirements by category

  - ### close

    public void close() throws IOException
    Throws:
      `IOException`